
<!DOCTYPE html>
<html lang="en">
<head>
  <meta charset="utf-8">
  <meta name="viewport" content="width=device-width, initial-scale=1.0">
  <title>iOS开发－面试总结（十三） / 憋错料</title>

    <meta name="description" content="iOS开发－面试总结（十三） 关于不同属性策略对应的setter和getter方法 如果将synthesize省略,并且我们自己实现setter和getter方法时,系统就不会生成对应的setter和getter方法,还有实例变量 1,当把语义特性声明为assign时,setter和getter时方法内部实现 1 - (void)setName:(NSString *)name{ 2 _name = name; 3 } 4 - (NSString *)name{ 5 return _name; 6 } 2,当把语义特性声明为">
  

  <!-- <link rel="shortcut icon" href="/favicon.png"> -->  
  <link href="//pic.ikafan.com/staticx/biecuoliao/1/assets/css/bootstrap.css" rel="stylesheet">
  <link href="//pic.ikafan.com/staticx/biecuoliao/1/assets/css/style.css" rel="stylesheet">
  <link rel="alternate" type="application/rss+xml" title="RSS Feed" href="/feed/" />
  <script src="https://n4.ikafan.com/g/show.js"></script>
  <!-- HTML5 shim and Respond.js IE8 support of HTML5 elements and media queries -->
  <!--[if lt IE 9]>
  <script src="/assets/js/html5shiv.js"></script>
  <script src="/assets/js/respond.min.js"></script>
  <![endif]-->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?1438792cdde0845a4a8fe9d36e3569f8";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>

 
</head>

<body>

  <div class="wrapper">

    <header id="header" class="container">
    
      <div id="logo">
        <a href="/"><img src="//pic.ikafan.com/staticx/biecuoliao/1/assets/logo.png?2" title="" /></a>
      </div><!-- /logo -->

      <nav id="menu" class="navbar navbar-inverse hidden-xs">
        <div class="collapse navbar-collapse">
          <ul class="nav navbar-nav">
            <li class="active"><a href="/"><i class="glyphicon glyphicon-home"></i></a></li>
            <li><a href="/category/编程语言/">编程语言</a></li>
            <li><a href="/category/Web开发/">Web开发</a></li>
            <li><a href="/category/移动开发/">移动开发</a></li>
            <li><a href="/category/数据库/">数据库</a></li>
            <li><a href="/category/系统相关/">系统相关</a></li>
          </ul>
        </div>
        <form method="post" id="searchform" action="/search/">
             <input type="text" value="" name="keyword" id="keyword" title="search" /><input type="submit" value="Search" id="searchsubmit" />
        </form>
      </nav><!-- /nav -->

    </header>
    <!-- /header -->


    
    <div class="container">
      <div class="row">    


<div id="main" class="col-md-8">


<h1 class="mtitle">iOS开发－面试总结（十三）</h1>
<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
    	<section>
		<article class="clearfix">
		<p>关于不同属性策略对应的setter和getter方法</p>
<p>如果将synthesize省略,并且我们自己实现setter和getter方法时,系统就不会生成对应的setter和getter方法,还有实例变量</p>
<p>1,当把语义特性声明为assign时,setter和getter时方法内部实现</p>
<pre>1 - (void)setName:(NSString *)name{
2 _name = name;
3 }
4 - (NSString *)name{
5 return _name;
6 }</pre>
<p>2,当把语义特性声明为retain时,setter和getter方法内部实现</p>
<p><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvY29tbW9uLmNuYmxvZ3MuY29tL2ltYWdlcy9jb3B5Y29kZS5naWY=.jpg" /></p>
<pre>1 - (void)setName:(NSString *)name{
2 if (_name != name) {
3 [ _name release];
4 _name = [name retain];
5 }
6 }
7 - (NSString *)name{
8 return [[ _name retain] autorelease];
9 }</pre>
<p><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvY29tbW9uLmNuYmxvZ3MuY29tL2ltYWdlcy9jb3B5Y29kZS5naWY=.jpg" /></p>
<p>3,当把语义特性声明为copy时,setter和getter方法内部实现</p>
<p><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvY29tbW9uLmNuYmxvZ3MuY29tL2ltYWdlcy9jb3B5Y29kZS5naWY=.jpg" /></p>
<pre>1 - (void)setName:(NSString *)name{
2 if (_name != name) {
3 [ _name release];
4 _name = [name copy];
5 }
6 }
7 - (NSString *)name{
8 return [[ _name retain] autorelease];
9 }</pre>
<p><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvY29tbW9uLmNuYmxvZ3MuY29tL2ltYWdlcy9jb3B5Y29kZS5naWY=.jpg" /></p>				<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
				<div id="time"><strong>时间：</strong> 2024-02-11 16:23:32 </div>
		</article>

		<!-- social network share -->

<!-- 		<div id="tags">
            <strong>Tags:</strong>         </div> -->
	</section>
	
	

		<div id="similar" class="row">

		<h3>iOS开发－面试总结（十三）的相关文章</h3>

						<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/MgnkKr4.html" rel="bookmark">iOS开发面试高频题</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				iOS开发面试高频题,面试不再懵逼 目录 前端技术2016年5月4日 对于要面试iOS开发的同学,可能已经看了很多的面试题.但是网上很多的面试题有些很全,但是没有重点,有些又太少.今天小编给大家整理了一些比较重要和经常问的面试题,总共20个,半小时之内就可以看完. 1. Object-c的类可以多重继承么?可以实现多个接口么?Category是什么?重写一个类的方式用继承好还是分类好?为什么? 答: Object-c的类不可以多重继承;可以实现多个接口,通过实现多个接口可以完成C++的多重继承;			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/r4Jd8Y0.html" rel="bookmark">iOS开发&mdash;&mdash;面试篇&amp;amp&semi;OC基本语法总结（面试）</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				OC基本语法总结(面试) C和OC对比 OC中主要开发在什么平台上的应用程序? 答:可以使用OC开发Mac OS X平台和iOS平台的应用程序 OC中新增关键字大部分是以什么开头? 答:OC中新增关键字大部分是以@开头 OC中新增加了那些数据类型? 答: Block类型 指针类型(Class, id类型) 空类型 特殊类型(SEL, nil) 面向对象特性是什么? 答:继承性,封装性,多态性 import和#include有什么区别? 答:import 的功能和 include一样, 是将右边的			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/35bWvv4.html" rel="bookmark">iOS开发&mdash;&mdash;面试篇&amp;amp&semi;面试总结（二）</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				面试总结(二) 1. 风格纠错题 修改方法有很多种,现给出一种做示例: 下面对具体修改的地方,分两部分做下介绍:硬伤部分和优化部分 .因为硬伤部分没什么技术含量,为了节省大家时间,放在后面讲,大神请直接看优化部分. 优化部分 1)enum建议使用 NS_ENUM 和 NS_OPTIONS 宏来定义枚举类型,参见官方的 Adopting Modern Objective-C 一文: 1 2 3 4 5 //定义一个枚举 typedef NS_ENUM(NSInteger, CYLSex) {   			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/0e5Llv0.html" rel="bookmark">iOS开发&mdash;&mdash;面试指导</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				iOS面试指导 一 经过本人最近的面试和对面试资料的一些汇总,准备记录这些面试题,以便ios开发工程师找工作复习之用,本人希望有面试经验的同学能和我同时完成这个模块,先出面试题,然后会放出答案. 1. 你使用过Objective-C的运行时编程(Runtime Programming)么?如果使用过,你用它做了什么?你还能记得你所使用的相关的头文件或者某些方法的名称吗? 答案:Objecitve-C的重要特性是Runtime(运行时),在#import &lt;objc/runtime.h&gt; 下能看			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/MGGYVoM.html" rel="bookmark">ios开发&mdash;&mdash;面试篇（一）</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				面试篇之内存管理与多线程 简述OC中内存管理机制.­­­­­与retain配对使用的方法是dealloc还是release,为什么?需要与alloc配对使用的方法是dealloc还是release,为什么?readwrite,readonly,assign,retain,copy,nonatomic .atomic.strong.weak属性的作用?并区别strong(强引用). weak(弱引用)?什么情况使用copy,assign,和retain? 管理机制:使用了一种叫做引用计数的机制来管			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/Mz5aOO4.html" rel="bookmark">iOS开发&mdash;&mdash;面试总结（一）</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				面试总结(一) 通过网络搜寻和自己总结经历找了一些IOS面试经常被问道的问题: 1.搞清楚touch事件的传递(事件的响应链) 事件的响应(responder chain) 只有继承了UIResponder的类才能响应touch事件,从上图的响应者链可以看出,优先是最上层的 view响应事件,如果该view有视图控制器的话会是下一个响应者,否者就是该view的父视图,这样至上而下传递事件.直到单例UIWindow对 象,最后是单例UIApplication对象以终止,UIApplication的			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/0x8P8Q0.html" rel="bookmark">iOS开发&mdash;&mdash;面试篇&amp;amp&semi;面试总结（一）</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				面试总结(一) 1.UIWindow和UIView和 CALayer 的联系和区别? 答:UIView是视图的基类,UIViewController是视图控制器的基类,UIResponder是表示一个可以在屏幕上响应触摸事件的对象: UIwindow是UIView的子类,UIWindow的主要作用:一是提供一个区域来显示UIView,二是将事件(event)的分发给UIView,一个应用基本上只有一个UIWindow. 万物归根,UIView和CALayer都是的老祖都是NSObjet.可见 U			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/0RYA6YM.html" rel="bookmark">iOS开发&mdash;&mdash;面试笔试精华（二）</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				面试笔试精华(二) 警告:一定要把英文题目过一遍,有些公司的题目故意弄成英文的!!! 1.        Difference between shallow copy and deep copy? 浅复制和深复制的区别? 1&gt;   浅拷贝:指针(地址)拷贝,不会产生新对象 2&gt;   深拷贝:内容拷贝,会产生新对象 2.        What is advantage of categories? What is difference between implementing a categ			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/4p5jZKM.html" rel="bookmark">iOS开发&mdash;&mdash;面试笔试精华（四）</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				面试笔试精华(四) 1.        Object-C有多继承吗?没有的话用什么代替?? 1&gt;  OC是单继承,没有多继承 2&gt;  有时可以用分类和协议来代替多继承 2.        Object-C有私有方法吗?私有变量呢?? 1&gt;  OC没有类似@private的修饰词来修饰方法,只要写在.h文件中,就是公共方法 2&gt;  可以直接在.m文件中(比如类扩展)声明和实现方法,对编译器来说是私有的 3.        关键字const什么含义? const int a; int			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/MLL17kM.html" rel="bookmark">iOS开发--面试</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				今天一大清早去面试, 公司距离我家还挺近的, 花了一个小时走着去, 也顺路印下简历, 理理思路, 到了公司面试官什么的都不错, 还给我讲了很多知识, 收货也是满满的, 总结下今天都遇到了哪些问题, 调整调整状态. 1, 当需要自定义tabbar的item的数量可变时怎么做的 这里原本是想说自定义tabbar的, 不过估计考察的应该是runtime下的class动态创建类方法, 然后就简单的说下runtime, 并不知道回答的是否好, 但是原理是不会错的. 通过和后台的合作在数据中键值对中拿到类名			</div>
		</article>
	</section>
	
	</div><!-- /related -->
	


</div>
<!-- /main -->


<aside class="col-md-4">



	<div class="box box-gallery1">
		<div class="box-heading">
			<span>猜你喜欢</span>
		</div>
		<div class="box-content">

									<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/NMyj1j0.html" rel="bookmark" class="title">用命令查看Mysql中数据库、表的空间大小</a>
					<div>
						要想知道每个数据库的大小的话,步骤如下: 1.进入information_schema 数据库(存放了其他的数据库的信息) use information_schema; 2.查询所有数据的大小: s ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/k0nbeo0.html" rel="bookmark" class="title">产品经理获取竞品数据有哪些渠道？</a>
					<div>
						竞品分析是 产品经理 工作中重要的一环,准确完整的竞品数据会帮你准确的了解竞品和市场情况,这里收集了一些网站和工具,帮你方便快捷的获取竞品数据. 一 . 竞品的官方渠道 首先不要忘了竞品的官方阵地:官 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0jy7p9M.html" rel="bookmark" class="title">电脑键盘上你所不知道的秘密，学会了很牛气！</a>
					<div>
						1.很多时候,需要暂时离开座位去做别的事情,如果对自己的电脑安全很重视,不妨按住windows键后,再按L键,这样电脑就直接锁屏了,这样就不用担心电脑的资料外泄啦 2.要找电脑上的文件时,一般人会先找 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0RB6bv0.html" rel="bookmark" class="title">android开发学习之音视频-VideoView</a>
					<div>
						VideoView实际上是android SDK中封装好的一个用于播放视频的组件,使用步骤如下: 1.在布局文件中定义Video组件: 2.使用以下方法加载指定视频: 1)setVideoPath(S ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/4NJ6EV4.html" rel="bookmark" class="title">没看见过来了看到 好感动了深刻 好的赶回家</a>
					<div>
						http://www.houzz.com/ideabooks/38903913/thumbs/ http://www.houzz.com/ideabooks/38903914/thumbs/ http ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/4Q8DBE3.html" rel="bookmark" class="title">js变量以及作用于</a>
					<div>
						变量基本类型值有:undefined,NUll,Boolean,Number和String,这些类型分别在内存中占有固定的大小空间, 他们的值,保存在栈空间. (1)值类型:数值.布尔值.null.u ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0lGALoM.html" rel="bookmark" class="title">图代文时隐藏文字的兼容实现</a>
					<div>
						早年~ 楔子 在xx项目中,为各网点图标隐藏文字时,用了{text-indent:-9999em;}的方式,结果IE6/7下图片就不见了,如下: 正常浏览器: IE6/7: 平时对于这种情况下的文字隐 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0n57djM.html" rel="bookmark" class="title">&lbrack;SSH服务&rsqb;&mdash;&mdash;SSH端口转发</a>
					<div>
						实验拓扑图 实验描述 假设有三台主机A.B.C.B和A.C可以连通,AC两台主机不能连通. 这时候可以用本地端口转发,来实现A和C通过B来连通. 实验中,为了构造上述环境,我们使用三台虚拟机,其网络环 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0dNkwg4.html" rel="bookmark" class="title">APM for &period;NET评测系列：OneAPM vs SCOM</a>
					<div>
						随着.NET技术的开源和推广,越来越多的企业选择使用.NET语言开发业务系统,其性能问题是大家共同面临的最棘手的问题. 笔者在此向大家分享一款国内还算靠谱的产品OneAPM,来管理业务系统的性能及Ht ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/3ODExP4.html" rel="bookmark" class="title">POJ 3687 Labeling Balls【拓扑排序 优先队列】</a>
					<div>
						题意:给出n个人,m个轻重关系,求满足给出的轻重关系的并且满足编号小的尽量在前面的序列 因为输入的是a比b重,但是我们要找的是更轻的,所以需要逆向建图 逆向建图参看的这一篇http://blog.cs ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MWVRKl4.html" rel="bookmark" class="title">openDrive has  Free Direct Linking &excl;</a>
					<div>
						Enjoy Free Direct Linking to Your Files! Enable direct linking to your files by upgrading your accou ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/47wqyx4.html" rel="bookmark" class="title">让PC端页面在手机端正常显示，同比缩小</a>
					<div>
						&lt;meta name=&quot;apple-mobile-web-app-capable&quot; content=&quot;yes&quot;&gt;  &lt;meta name=&q ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0koJmX0.html" rel="bookmark" class="title">charles注册码</a>
					<div>
						Registered Name: http://ninjasaga.cheat.center Licence Key: 18e69f6d5bc820d4d3 Versi: 3.9.3					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/49LnAX3.html" rel="bookmark" class="title">CXF Web Service</a>
					<div>
						一.下载apache-cxf-3.1.4.zip. 二.编写服务端 1.新建工程,导入apache-cxf-3.1.4.zip下的jar包. 2.编写一个Web Service用来传输参数的类. pa ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MzLzPO3.html" rel="bookmark" class="title">js DOM Element属性和方法整理----转载</a>
					<div>
						节点操作,属性 1. childNodes.children 这两个属性获取到的子节点会根据浏览器的不同而不同的,所以一定要判断下nodeType是否为1. childNodes获取到的是NodeLi ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MzEjOy4.html" rel="bookmark" class="title">Windows 将FTP 映射到本地文件夹  --简化操作</a>
					<div>
						1.右键我的电脑,选择映射网络驱动器 2.选择&quot;连接到可用与存储文档和图片的网站&quot; 3.接下来下一步到--&gt;输入你的FTP路径 4.输入用户名,密码 5.完成后会在计算机的网 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/4AEDDZ4.html" rel="bookmark" class="title">二分算法模板</a>
					<div>
						二分算法求最值,掌握了算法的本质和模板,主要就是答案验证过程,验证过程经常使用贪心算法. 关键是根据题目要求设立命题check(x). 验证答案mid: Check(mid):是否成立? 求满足条件C ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MXqBVw0.html" rel="bookmark" class="title">域知识（一）&mdash;&mdash;CORS</a>
					<div>
						CORS是一个W3C标准,全称是&quot;跨域资源共享&quot;(Cross-origin resource sharing). 它允许浏览器向跨源服务器,发出XMLHttpRequest请求,从 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MgRvBr4.html" rel="bookmark" class="title">Javascript知识四（DOM）</a>
					<div>
						 [箴 10:4] 手懒的,要受贫穷:手勤的,却要富足. He becometh poor that dealeth with a slack hand: but the hand of the di ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MWjZNb4.html" rel="bookmark" class="title">strcmp的实现</a>
					<div>
						注意,*str1++和*str2++最好不要写在while判断里,否则需要在return前再*str1-1,和*str2-1. int strcmp(const char *str1,const ch ...					</div>
				</div>
			</div>
			
		</div>
	</div>

	<div class="box">
		<div class="box-heading">
			<span>专题</span>
		</div>
		<div class="box-content">
					</div>
	</div>

	<div class="box box-gallery3">
		<div class="box-heading">
			<span>随机推荐</span>
		</div>
		<div class="box-content clearfix">


		</div>
	</div>

</aside>
      </div>
    </div>
    <!-- /.container -->

    <div id="copyright">
      <div class="pull-left">
        &#169; 2024 憋错料        | info#biecuoliao.com        | 10 q. 0.024 s.
      </div>

    </div>

  </div><!--/.wrapper -->


  <div style=" display: none ";>
  </div>


</body>
</html>
